﻿using AjaxControlToolkit;
using System;
using System.Text;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.NavigationControls;


namespace EnsureTemplate.ClassFiles
{
    internal class ElementNode : DataTreeNode
    {
        private const string _templateId = "ElementTemplate";

        // The Value property will contain comma-delimited values:
        // 1) "Element" - so drag & drop will know this is an element
        // 2) ReferenceId - so drag & drop will know the reference id
        internal ElementNode(Guid fakeThing)
        {
            TemplateId = _templateId;
            Key = fakeThing.ToString("n").ToUpper();
            Text = fakeThing.ToString("n").ToUpper();
            Value = "Element," + fakeThing.ToString("n").ToUpper();
            CssClass = "elementNode";
            SelectedCssClass = "elementNodeSelected";
        }
             
        internal void AddToNode(DataTreeNode parentNode)
        {
            parentNode.Nodes.Add(this);
            SetupTemplate();
        }

        /// <summary>
        /// This can only be done AFTER the node has been added to the tree
        /// </summary>
        private void SetupTemplate()
        {
            Guid fakeThing = Guid.NewGuid();
            EnsureTemplate();
            bool isLocal = false;
            string commandArgument = fakeThing.ToString("n").ToUpper();
            
            Label lblType = FindControl("lblType") as Label;
            StringBuilder scType = new StringBuilder(commandArgument);

            if (isLocal)
            {
                scType.Append(" (Local)");
            }
            scType.Append(":");

            lblType.Text = scType.ToString();

            Label lblName = FindControl("lblName") as Label;
            lblName.Text = "Label";

            Label lblCh = FindControl("lblCreditsHours") as Label;
            lblCh.Text = CreditsHoursString();

           
            ToolTip = "tooltip";
            

            if (isLocal)
            {
                ImageButton ibEdit = FindControl("ibEditElement") as ImageButton;
                ibEdit.Visible = true;
                ibEdit.CommandArgument = commandArgument;
            }
            
            ImageButton ibRemove = FindControl("ibRemoveElement") as ImageButton;
            ibRemove.CommandArgument = commandArgument;

            ConfirmButtonExtender cbe = FindControl("cbeRemoveElement") as ConfirmButtonExtender;
            cbe.ConfirmText = string.Format("Are you sure you want to delete \"{0}\"?", " this thing?");
        }

        private string CreditsHoursString()
        {
            string returnValue = "(Required)";
            //string typname = "All";
            //switch (typname)
            //{
            //    case "All":
            //        //returnValue = "(Required)";
            //        break;
            //    case "Ordered":
            //        //returnValue = string.Format("({0})", Element.SortValue + 1);
            //        break;
            //    case "N of X":
            //        break;
            //    case "Number of Credits":
            //        returnValue = string.Format("({0} Credits)", RequirementValidator.GetCreditsForElement(Element).ToString());
            //        break;
            //    case "Number of Hours":
            //        returnValue = string.Format("({0} Hours)", RequirementValidator.GetHoursForElement(Element).ToString());
            //        break;
            //    case "Recommended":
            //        //returnValue = "(Recommended)";
            //        break;
            //    default:
            //        returnValue = "(Undefined)";
            //        break;
            //}

            return returnValue;
        }
    }
}