﻿var REQUIREMENT_VALUE = 'Requirement';
var MAY_HAVE_SUBREQS_VALUE = 'MayHaveSubReqs';
var REF_ID_INDEX = 1;

// scroll up or down if an item is dragged outside the viewing area.
function dragMove(sender, args) {
    var distanceToEdge = 30;
    var scrollSpeed = 5;
    var y = args.get_y();
    var windowHeight = $(window).height();
    var scrollTop = $(window).scrollTop();
    if (y > (windowHeight + scrollTop) - distanceToEdge) {
        scrollBy(0, scrollSpeed);
    } else if (y < (scrollTop + distanceToEdge)) {
        scrollBy(0, -scrollSpeed);
    }
}

// cancel the drop if it is not a valid drop
function nodeDropping(sender, args) {
    alert("hello");
    var sourceNode = args.get_sourceNodes()[0];
    var destNode = args.get_destNode();
    var isDroppedOn = (args.get_dragDropPoint() == $IG.DragDropPoint.On);
    var isSourceRequirement = isRequirementNode(sourceNode);
    var isDestRequirement = isRequirementNode(destNode);
    var isDestOnTrunk = (destNode.get_parentNode() == null);
    var isSourceOnTrunk = (sourceNode.get_parentNode() == null);
    var destReqNode = destNode;
    if (!isDestRequirement || !isDroppedOn) {
        destReqNode = destNode.get_parentNode();
    }
    var mayDestRequirementHaveSubReqs = true;
    if (destReqNode !== null) {
        mayDestRequirementHaveSubReqs = mayHaveSubrequirements(destReqNode);
    }
    var mayDestParentRequirementHaveSubReqs = !isDestOnTrunk && (mayHaveSubrequirements(destNode));
    var cancelDropping = false;
    //may not drop a requirement on an element
    cancelDropping = (isDroppedOn && isSourceRequirement && !isDestRequirement);
    //alert("1 " + cancelDropping);
    // may not drop a requirement on a requirement that can't have subrequirements
    cancelDropping = (cancelDropping || (isSourceRequirement && !mayDestRequirementHaveSubReqs));
    //alert("2 " + cancelDropping);
    // may not drop an element on an element
    cancelDropping = (cancelDropping || (isDroppedOn && !isSourceRequirement && !isDestRequirement));
    //alert("3 " + cancelDropping);
    // may not drop an element between trunk nodes
    cancelDropping = (cancelDropping || (!isDroppedOn && isDestOnTrunk && !isSourceRequirement));
    //alert("4 " + cancelDropping);
    // may not drop an element into a different requirement that already has an element with the same reference id
    //alert(getReferenceId(sourceNode));
    cancelDropping = (cancelDropping || (!isSourceRequirement && (sourceNode.get_parentNode() != destReqNode && requestNodeContainsreferenceElement(getReferenceId(sourceNode), destReqNode))));
    //alert("5 " + cancelDropping);
    // may not re-order root items
    //cancelDropping = (cancelDropping || (!isDroppedOn && isSourceOnTrunk && isDestOnTrunk));
    //alert("6 " + cancelDropping);
    args.set_cancel(cancelDropping);
    //   setText(cancelDropping);
}


function isRequirementNode(node) {
    return node.get_valueString().indexOf(REQUIREMENT_VALUE) > -1
}

function mayHaveSubrequirements(node) {
    return node.get_valueString().indexOf(MAY_HAVE_SUBREQS_VALUE) > -1;
}


// returns whether or not a request node contains an element with the given reference id
function requestNodeContainsreferenceElement(refId, destNode) {
    for (var i = 0; i < destNode.get_childrenCount(); i++) {
        var childNode = destNode.get_childNode(i);
        if (childNode.get_valueString().indexOf(refId) > -1) {
            return true;
        }
    }
    return false;
}

function getNodeDropStyle(cancelDropping, isNodeRequirement) {
    if (cancelDropping) {
        if (isNodeRequirement) {
            return "requirementNodeNoDrop";
        } else {
            return "elementNodeNoDrop";
        }

    } else {
        if (isNodeRequirement) {
            return "requirementNodeOkDrop";
        } else {
            return "elementNodeOkDrop";
        }
    }
}

// parse out the reference id from the node's Value property
function getReferenceId(elementNode) {
    var valueArray = elementNode.get_valueString().split(',');
    return valueArray[REF_ID_INDEX];
}

// used for debugging
function setText(text) {
    var elem = document.getElementById('eventTester');
    elem.innerHTML = text;
}